#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

int main(int argc, char *argv[]){
  
  int socketDescriptor;
  int portNummer;
  int n;

  //aufbau der struktur sockaddr_in
  //deklaration in netinet/in.h 
  /*
   struct sockaddr_in{
      short   sin_family;  //muss AF_INET sein
      u_short sin_port;
      struct  in_addr sin_addr;
      char    sin_zero[8]; //nicht verwendet, muss zero sein
   };
   */
  struct sockaddr_in serverAdresse;

  //aufbau der struktur hostent
  //deklaration in netdb.h
  /*
  The hostent structure is defined in <netdb.h> as follows:

  struct hostent {
     char  *h_name;             // official name of host
     char **h_aliases;          // alias list
     int    h_addrtype;         // host address type
     int    h_length;           // length of address
     char **h_addr_list;        // list of addresses
  }
  #define h_addr h_addr_list[0] // for backward compatibility
  */
  struct hostent *server;

  char buffer[256];

  if (argc < 3) {
    fprintf(stderr,"usage %s hostname port\n", argv[0]);
    exit(0);
  }

  portNummer = atoi(argv[2]);
  socketDescriptor = socket(AF_INET, SOCK_STREAM, 0);

  if (socketDescriptor < 0){
      perror("ERROR opening socket");
      exit(1);
  }

  server = gethostbyname(argv[1]);

  if (server == NULL) {
    fprintf(stderr,"ERROR, no such host\n");
    exit(0);
  }

  //struktur serverAdresse initialisieren
  //der a->b operator bedeutet: 
  //zugriff auf die variable b in der struktur 
  //auf die der pointer a zeigt

  //&a adresse von a
  bzero((char *) &serverAdresse, sizeof(serverAdresse));

  //der a.b operator bedeutet:
  //zugriff auf die variable b der struktur a
  serverAdresse.sin_family = AF_INET;

  //bcopy kopiert n bytes vom ersten 
  //string *s1 in den zweiten string *s2
  bcopy((char *)server->h_addr,  //erster string
  	(char *)&serverAdresse.sin_addr.s_addr,  //zweiter string
	server->h_length  //n
  	);
  serverAdresse.sin_port = htons(portNummer);

  /* Now connect to the server */
  if (connect(socketDescriptor,&serverAdresse,sizeof(serverAdresse)) < 0) {
    perror("ERROR connecting");
    exit(1);
  }

  while(1){
  printf("bitte nachricht eingeben: ");
  bzero(buffer,256);
  fgets(buffer,255,stdin);

  n= write(socketDescriptor, buffer, strlen(buffer));
  if(n<0){
    perror("ERROR writing to socket");
    exit(1);
  }

  /* Now read server response */

  //char buffer[256];
  
  bzero(buffer,256);
  n = read(socketDescriptor,buffer,255);
  if (n < 0){
      perror("ERROR reading from socket");
      exit(1);
  }
  printf("%s\n",buffer);
  
  if(bufferStartsWith221(buffer)){break;}

  //printf("true oder false: %d",bufferStartsWith221(buffer));
  
  }
 
  return 0;
  
}

int bufferStartsWith221(char *buffer){
  unsigned char flag = 0;
  char *substring;
  int i=0;
  for(i=0; i<3;i++){
    substring[i] = buffer[i];
  }
  substring[3]='\0';
  //printf("substring: %s\n", substring);

  if(atoi(substring)==221)flag=1;

  //printf(" wert von flag %d",flag);
  
  return flag;
}
