#include <stdio.h>
#include <stdlib.h>

#include <netdb.h>
#include <netinet/in.h>

#include <string.h>

void doProcessing(int);

int main( int argc, char *argv[] ) {

  int portNum;
  int socketDescriptor;
  int newSocketDescriptor;
  int clilen;
  //char buffer[256];
  //int  n;


  // struktur fuer die socket-adresse 
  /*
  struct sockaddr_in {
    short int sin_family;           address-family z.b. AF_INET
    unsigned short int sin_port;    16-bit portnummer
    struct in_addr sin_addr;        32-bit IP-adresse
    unsigned char sin_zero[8];      not used
  };
  */

  //eine struktur = struct ist eine klasse ohne funktionen
  struct sockaddr_in serverAddress , clientAddress;
  
  //zuerst ueberpruefen wir, ob der user eine portnummer uebergibt
  if(argc != 2){
    printf("Aufruf: serverSocket <portnummer>\n");
  }else{
    portNum = atoi(argv[1]);
    printf("socket nr %d wird geoeffnet\n",portNum);
    //return 0;
  }
  
  //aufruf der socket-funktion
  // AF_INET: address-family=IPv4
  // SOCK_STREAM: wir moechten einen stream-socket haben, d.h. eine tcp-verbindung
  // IPPROTO_TCP: tcp wird verwendet, das ist bei der kombi aus ipv4 und stream aber ohnehin default
  socketDescriptor = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

  if (socketDescriptor < 0) {
    perror("ERROR opening socket");
    exit(1);
  }

  /* Initialize socket structure */
  bzero((char *) &serverAddress, sizeof(serverAddress));
  //portno = 5001;

  serverAddress.sin_family = AF_INET;
  serverAddress.sin_addr.s_addr = INADDR_ANY;
  serverAddress.sin_port = htons(portNum);

  /* Now bind the host address using bind() call.*/
  if (bind(socketDescriptor, (struct sockaddr *) &serverAddress, sizeof(serverAddress)) < 0) {
    perror("ERROR on binding");
    exit(1);
  }

  /* Now start listening for the clients, here process will
   * go in sleep mode and will wait for the incoming connection
   */

  //der zweite paramter der listen-funktion gibt die laenge der warteschlange fuer anstehende verbindungen an
  listen(socketDescriptor,5);
  clilen = sizeof(clientAddress);

  //hier starten wir eine endlos-schleife, der server soll ja endlos zu diensten sein

  while(1){

    // verbindungswunsch des clients akzeptieren
    newSocketDescriptor = accept(socketDescriptor, (struct sockaddr *)&clientAddress, &clilen);
    
    if (newSocketDescriptor < 0) {
      perror("ERROR on accept");
      exit(1);
    }

    // neuen prozess erzeugen; kindsprozess erbt 
    
    int pid = fork();
    
    if (pid < 0) {
      perror("ERROR on fork");
      exit(1);
    }
    
    if (pid == 0) {
      /* This is the client process */
      close(socketDescriptor);
      doProcessing(newSocketDescriptor);
      exit(0);
    }else{
      close(newSocketDescriptor);
    }
    
  }//ende while
  
}//ende main

  
void doProcessing(int socketDescriptor){
  int n;
  char buffer[256];
  while(1){
  bzero(buffer,256);
  
  n = read( socketDescriptor,buffer,255 );
  
  if (n < 0) {
    perror("ERROR reading from socket");
    exit(1);
  }
  
  printf("Here is the message: %s\n",buffer);
  
  /* Write a response to the client */
  //  n = write(socketDescriptor,"I got your message",18);
  n = write(socketDescriptor,buffer,sizeof(buffer));
    
  if (n < 0) {
    perror("ERROR writing to socket");
    exit(1);
  }
  }
}


